--- xodtemplate.c-orig	2007-01-19 15:02:01.000000000 -0700
+++ xodtemplate.c	2007-01-22 13:09:30.000000000 -0700
@@ -97,6 +97,26 @@
 char xodtemplate_cache_file[MAX_FILENAME_LENGTH];
 
 
+#ifdef DEBUG0
+static char *XObjectNames[] = {
+	"NONE",
+	"TIMEPERIOD",
+	"COMMAND",
+	"CONTACT",
+	"CONTACTGROUP",
+	"HOST",
+	"HOSTGROUP",
+	"SERVICE",
+	"SERVICEDEPENDENCY",
+	"HOSTGROUPESCALATION",
+	"SERVICEESCALATION",
+	"HOSTESCALATION",
+	"HOSTDEPENDENCY",
+	"HOSTEXTINFO",
+	"SERVICEEXTINFO",
+	"SERVICEGROUP"
+};
+#endif
 
 /******************************************************************/
 /************* TOP-LEVEL CONFIG DATA INPUT FUNCTION ***************/
@@ -1034,6 +1054,7 @@
 		new_servicegroup->servicegroup_name=NULL;
 		new_servicegroup->alias=NULL;
 		new_servicegroup->members=NULL;
+		new_servicegroup->sla_target=0.0;
 		new_servicegroup->has_been_resolved=FALSE;
 		new_servicegroup->register_object=TRUE;
 		new_servicegroup->_config_file=config_file;
@@ -1558,6 +1579,10 @@
 #ifdef DEBUG0
 	printf("xodtemplate_add_object_property() start\n");
 #endif
+#ifdef DEBUG1
+	if (input)
+		printf("\tRaw Input: \"%s\"\n", input);
+#endif
 
 
 	/* check to see if we should process this type of object */
@@ -1670,6 +1695,9 @@
 	printf("STRIPPED VALUE: '%s'\n\n",value);
 	*/
 
+#ifdef DEBUG1
+	printf("xodtemplate_add_object_property: %s  \"%s\" => \"%s\"\n", XObjectNames[xodtemplate_current_object_type], variable, value);
+#endif
 
 	switch(xodtemplate_current_object_type){
 
@@ -2043,6 +2071,9 @@
 				return ERROR;
 			        }
 		        }
+		else if(!strcmp(variable,"sla_target")){
+			temp_servicegroup->sla_target = strtod(value,NULL);
+		        }
 		else if(!strcmp(variable,"register"))
 			temp_servicegroup->register_object=(atoi(value)>0)?TRUE:FALSE;
 		else{
@@ -5675,6 +5706,8 @@
 		this_servicegroup->alias=strdup(template_servicegroup->alias);
 	if(this_servicegroup->members==NULL && template_servicegroup->members!=NULL)
 		this_servicegroup->members=strdup(template_servicegroup->members);
+	if(!this_servicegroup->sla_target && template_servicegroup->sla_target)
+		this_servicegroup->sla_target=template_servicegroup->sla_target;
 
 #ifdef DEBUG0
 	printf("xodtemplate_resolve_servicegroup() end\n");
@@ -7755,7 +7788,7 @@
 		return OK;
 
 	/* add the  service group */
-	new_servicegroup=add_servicegroup(this_servicegroup->servicegroup_name,this_servicegroup->alias);
+	new_servicegroup=add_servicegroup(this_servicegroup->servicegroup_name,this_servicegroup->alias,this_servicegroup->sla_target);
 
 	/* return with an error if we couldn't add the servicegroup */
 	if(new_servicegroup==NULL){
@@ -9378,6 +9411,7 @@
 			fprintf(fp,"\tservicegroup_name\t%s\n",temp_servicegroup->servicegroup_name);
 		if(temp_servicegroup->alias)
 			fprintf(fp,"\talias\t%s\n",temp_servicegroup->alias);
+		fprintf(fp,"\tsla_target\t%f\n",temp_servicegroup->sla_target);
 		if(temp_servicegroup->members)
 			fprintf(fp,"\tmembers\t%s\n",temp_servicegroup->members);
 		fprintf(fp,"\t}\n\n");
